[GtkTemplate (ui="/v/ginput/panel.ui")]
public abstract class Panel : Adw.Bin, Gtk.Buildable
{
    [GtkChild]
    protected unowned Adw.Bin content_bin;
    [GtkChild]
	protected unowned Gtk.Box main_box;
	[GtkChild]
    protected unowned Adw.Bin titlebar_bin;
    [GtkChild]
	protected unowned Adw.HeaderBar titlebar;

    protected Adw.WindowTitle titlebar_title;

    protected Panel(string name)
    {
        this.name = name;
        
        titlebar_title = new Adw.WindowTitle(this.name, "");
        titlebar.set_title_widget(titlebar_title);
    }

    construct
    {
        init_template();
    }

    void add_child(Gtk.Builder builder, Object child, string? type)
    {
        if(type != null && type == "content")
        {
            content_bin.set_child(((Gtk.Widget) child));
            return;
        }

        base.add_child(builder, child, type);
    }
}
